#!/bin/sh

{% if tinc_bridge_name %}
# ensure the bridge exists and has the correct ip
brctl addbr {{ tinc_bridge_name }} || true
ip link set mtu {{ mtu }} dev {{ tinc_bridge_name }}
ip link set up dev {{ tinc_bridge_name }}
ip addr add {{ ips[inventory_hostname] }}/{{ ip_maskbits }} dev {{ tinc_bridge_name }} || true

# add interface to the bridge
brctl addif {{ tinc_bridge_name }} $INTERFACE
ip link set mtu {{ mtu }} dev $INTERFACE
{% else %}
ip addr add {{ ips[inventory_hostname] }}/{{ ip_maskbits }} dev $INTERFACE
ip link set mtu {{ mtu }} dev $INTERFACE
{% endif %}

ip link set up dev $INTERFACE

# Routes
{% for host in groups['all'] %}
{% if host != inventory_hostname and 'subnets' in hostvars[host] %}
{% for subnet in hostvars[host]['subnets'] %}
{% if 'route' not in subnet or subnet['route'] == True %}
ip route add {{ subnet['cidr'] }} via {{ ips[host] }} metric {% if 'metric' in subnet %}{{ subnet['metric'] }}{% else %}{{ default_metric }}{% endif %} dev $INTERFACE

{% endif %}
{% endfor %}
{% endif %}
{% endfor %}

{% if 'subnets' in hostvars[inventory_hostname] and hostvars[inventory_hostname]['subnets']|length > 0 %}
sysctl -w net.ipv4.conf.${INTERFACE}.forwarding=1
{% endif %}
